import Test.QuickCheck

type Queue a = [a]
empty = []
add x q = q ++ [x]
isEmpty q = null q
front (x:q) = x
remove (x:q) = q

type Queue2 a = ([a], [a])
empty2 = ([],[])
add2 x (f,b) = flipQ (f, x:b)
isEmpty2 (f,b) = null f
front2 (x:f, b) = x
remove2 (x:f, b) = flipQ (f,b)

flipQ ([], b) = (reverse b, [])
flipQ q       = q


prop_isEmpty2 q      = invariant q ==> isEmpty2 q == (q == empty2)
prop_front_empty x   = front2 (add2 x empty2) == x
prop_front_add x q   = invariant q && not (isEmpty2 q) ==> front2 (add2 x q) == front2 q
prop_remove_empty x  = remove2 (add2 x empty2) == empty2
prop_remove_add x q  = invariant q && not (isEmpty2 q) ==> remove2 (add2 x q) == add2 x (remove2 q)

invariant :: Queue2 Integer -> Bool
invariant (f,b) = not (null f) || null b
