import Test.QuickCheck

quickCheckN n = quickCheckWith $ stdArgs { maxSuccess = n }

insert :: Ord a => a -> [a] -> [a]
insert x []  = [x]
insert x r@(y:ys)
    | x <= y     = x : r
    | otherwise  = y : insert x ys

ordered :: (Ord a) => [a] -> Bool
ordered []   = True
ordered [x]  = True
ordered (x1:r@(x2:xs))
    | x1 <= x2   = ordered r
    | otherwise  = False


prop_InsertOrdered      :: Integer -> [Integer] -> Property
prop_InsertOrdered x xs  = ordered xs ==>              ordered (insert x xs)

prop_InsertOrdered2     :: Integer -> Property
prop_InsertOrdered2 x    = forAll orderedList $ \xs -> ordered (insert x xs)
